import ts from "typescript";
import * as Method from "./Method";
import * as ReturnStatement from "./ReturnStatement";
export { Method };
export const create = (factory, list, option) => {
    const variableStatements = list.map(params => {
        return Method.create(factory, params, option);
    });
    const arrowFunction = factory.ArrowFunction.create({
        typeParameters: [
            factory.TypeParameterDeclaration.create({
                name: "RequestOption",
            }),
        ],
        parameters: [
            factory.ParameterDeclaration.create({
                name: "apiClient",
                type: factory.TypeReferenceNode.create({
                    name: "ApiClient",
                    typeArguments: [
                        factory.TypeReferenceNode.create({
                            name: "RequestOption",
                        }),
                    ],
                }),
            }),
            factory.ParameterDeclaration.create({
                name: "baseUrl",
                type: ts.factory.createKeywordTypeNode(ts.SyntaxKind.StringKeyword),
            }),
        ],
        body: factory.Block.create({
            statements: [...variableStatements, ReturnStatement.create(factory, list)],
            multiLine: true,
        }),
    });
    return factory.VariableStatement.create({
        modifiers: [ts.factory.createToken(ts.SyntaxKind.ExportKeyword)],
        declarationList: factory.VariableDeclarationList.create({
            declarations: [
                factory.VariableDeclaration.create({
                    name: "createClient",
                    initializer: arrowFunction,
                }),
            ],
            flag: "const",
        }),
    });
};
//# sourceMappingURL=index.js.map